// Copyright (C) 1998 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#include "mouse.hh"

int  Mouse::num_buttons;
bool Mouse::mouse_ready = false;

int 
Mouse::init()
{
  if (CL_Input::pointers[0] && CL_Input::pointers[0]->get_cursor(0)) {
    cout << "Mouse Support available, " 
	 << (num_buttons = CL_Input::pointers[0]->get_num_buttons())
	 << " buttons found." << endl;
    mouse_ready = true;
    return 1;
  } else {
    mouse_ready = false;
    return 0;
  }

}

int
Mouse::get_x()
{
  assert(mouse_ready);
  return (int)CL_Input::pointers[0]->get_cursor(0)->get_x();
}

int
Mouse::get_y()
{
  assert(mouse_ready);
  return (int)CL_Input::pointers[0]->get_cursor(0)->get_y();
}

bool
Mouse::is_pressed(int button)
{
  if (button > num_buttons || button < 0) {
    cout << "Mouse Button Number wrong!" << endl;
    return false;
  }

  if (mouse_ready) {
    //    cout << button << CL_Input::pointers[0]->get_button(button)->is_pressed() << endl;
    return CL_Input::pointers[0]->get_button(button)->is_pressed();
  } else {
    cout << "Mouse not ready" << endl;
    return false;
  }
}

/* EOF */
