// Copyright (C) 1998 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#include <vector>
#include <cstdio>
#include <ctime>

#include "pingubmpmap.hh"
#include "background.hh"
#include "world.hh"

//CL_Surface* World::gfx_bg = 0;
CL_ResourceManager* World::resource;

World::World()
{

}

World::~World()
{
  delete map;
  delete  bg;
}

void 
World::draw_pingus()
{
  for(int i=0; i < pingu.size(); ++i) {
    pingu[i].draw();
    //    cout << "Pingu_DATA" << pingu[i].get_x() << " " << pingu[i].get_x() << endl;
    map->mark_dirty(pingu[i].get_x()+16,pingu[i].get_y()+16,32,32);
    bg->mark_dirty(pingu[i].get_x()+16,pingu[i].get_y()+16,32,32);
  }  
}

// draw the basic background pattern
void 
World::draw_background()
{
  bg_is_drawn = true;
  bg->draw();
  /*  if (!gfx_bg)
    return;

  for(int y=0; y < 600; y += gfx_bg->get_provider()->get_height())
    for(int x=0; x < 800; x += gfx_bg->get_provider()->get_width())
      gfx_bg->put_screen(x,y);
  */
}

void 
World::draw_playground()
{
  pg_is_drawn = true;

  if (map) map->put_screen(0,0);
}


void 
World::draw_foreground()
{
  fg_is_drawn = true;
}

// Merge the different layers on the screen together
void 
World::draw()
{
  draw_background();
  draw_playground();
  draw_pingus();
  draw_foreground();
  
  /*
  static int count;

  // Sets how often the screen should be readrawn
  
  if (++count > 1) { 
    bg_is_drawn = pg_is_drawn = fg_is_drawn = false;
    count = 0;
  }
  
  
  if (!bg_is_drawn) draw_background();
  draw_pingus();
  if (!pg_is_drawn) draw_playground();
  if (!fg_is_drawn) draw_foreground();
  */
}

void 
World::let_move()
{
  /*
  // Create new pingus
  for(int i=0; i < entrance.size(); ++i) {
    if (entrance[i]->pingu_ready()) {
      pingu.push_back(entrance[i]->get_pingu());
    }
  }
  */
  for(int i=0; i < pingu.size(); ++i) {
    pingu[i].let_move();
  }
}

void 
World::save()
{
}

void 
World::load()
{
}

void
World::load_data(CL_ResourceManager* res)
{
  resource = res;
}

void 
World::init(PLF* level_data)
{
  //  gfx_bg = CL_Res_Surface::load(level_data->get_bg(), *resource);
  colmap.load(level_data->get_mapfile());

  // load the foreground map
  if (level_data->map_type() == TILE)
    map = new PinguTileMap(level_data, resource);
  else
    map = new PinguBmpMap(level_data->get_fg(), resource);
  
  // load the background map
  bg = new Background(level_data->get_bg(), resource);

  fg_is_drawn = false;
  pg_is_drawn = false;
  bg_is_drawn = false;
  
  int pal;
  srand(time(NULL));

  // Creating Exit and Entrance
  // exit.push_back(new Exit);
  // entrance.push_back(new Entrance);

  
  // Setting Pingus at random positions
  pingu.resize(50);

  for(int i=0; i < pingu.size(); ++i) {
    pingu[i].set_pos( rand() % 800, rand() % 300);
  }
  

  puts("World init : loading gfx");

  Pingu::set_colmap(&colmap);
  Pingu::set_map(map);

  puts("World init : finished");
}

vector<Pingu>*
World::get_pingu_p()
{
  return &pingu;
}

/* EOF */
